#include <Arduino.h>
//#include "include.h"

// FILL IN PART //
// *****************************************//

const double K_11 = 0;
const double K_12 = 0;
const double K_13 = 0;
const double K_14 = 0;

const double K_21 = 0;
const double K_22 = 0;
const double K_23 = 0;
const double K_24 = 0;

// *****************************************//

double dev1;
double dev2;
double dev3;
double dev4;

double u_1_LQR;
double u_2_LQR;

void LQR_controller(double y[4], unsigned int u[2]) {

  // calculate deviations from steady state
  dev1 = (y[0] - h1_offset) - h1_ss;
  dev2 = (y[1] - h2_offset) - h2_ss;
  dev3 = (y[2] - h3_offset) - h3_ss;
  dev4 = (y[3] - h4_offset) - h4_ss;

  //compute control input u = -Kx
  u_1_LQR = -(K_11*dev1 + K_12*dev2 + K_13*dev3 + K_14*dev4);
  u_2_LQR = -(K_21*dev1 + K_22*dev2 + K_23*dev3 + K_24*dev4);

  //add offset steady state tensions
  ctrl_1 = u_1_LQR + v1_ss;
  ctrl_2 = u_2_LQR + v2_ss;
  
  // to avoid negative int conversion to large unsigned int
  if (ctrl_2 < 0) {
    u[1] = 0;
  } else {
    u[1] = ctrl_2 * K_d2V; //feedback from tank 2 (right) to right pump
  }
  if (ctrl_1 < 0) {
    u[0] = 0;
  } else {
    u[0] = ctrl_1 * K_d2V; //feedback form tank 1 (left) to left pump
  }

//  Serial.print(ctrl_1);
//  Serial.print("\t");
//  Serial.print(ctrl_2);
//  Serial.print("\t");

  //The values written to u will be aplied to the pumps
}
