#include <Arduino.h>
//#include "include.h"



// FILL IN PART //
// *****************************************//

//integral matrix
const double K_int_i_11 = 0;
const double K_int_i_12 = 0;
const double K_int_i_21 = 0;
const double K_int_i_22 = 0;

//inner control matrix
const double K_int_inner_11 = 0;
const double K_int_inner_12 = 0;
const double K_int_inner_13 = 0;
const double K_int_inner_14 = 0;

const double K_int_inner_21 = 0;
const double K_int_inner_22 = 0;
const double K_int_inner_23 = 0;
const double K_int_inner_24 = 0;

// *****************************************//

double u_1_LQR_int;
double u_2_LQR_int;

void LQR_int_controller(double y[4], unsigned int u[2]) {

  // calculate deviations from steady state
  dev1 = (y[0] - h1_offset) - h1_ss;
  dev2 = (y[1] - h2_offset) - h2_ss;
  dev3 = (y[2] - h3_offset) - h3_ss;
  dev4 = (y[3] - h4_offset) - h4_ss;

  sumDev1 -= dev1 * TIMESTEP * 0.001; //integral of the deviation
  sumDev2 -= dev2 * TIMESTEP * 0.001; //integral of the error

  //compute control input u = -K_inner * x
  u_1_LQR = -(K_int_inner_11*dev1 + K_int_inner_12*dev2 + K_int_inner_13*dev3 + K_int_inner_14*dev4);
  u_2_LQR = -(K_int_inner_21*dev1 + K_int_inner_22*dev2 + K_int_inner_23*dev3 + K_int_inner_24*dev4);

  //compute integral part of control input
  u_1_LQR_int = -(K_int_i_11*sumDev1 + K_int_i_12*sumDev2);
  u_2_LQR_int = -(K_int_i_21*sumDev1 + K_int_i_22*sumDev2);  

  //sum the two control inputs
  ctrl_1 = u_1_LQR + u_1_LQR_int;
  ctrl_2 = u_2_LQR + u_2_LQR_int;
  
  // to avoid negative int conversion to large unsigned int
  if (ctrl_2 < 0) {
    u[1] = 0;
  } else {
    u[1] = ctrl_2 * K_d2V; //feedback from tank 2 (right) to right pump
  }
  if (ctrl_1 < 0) {
    u[0] = 0;
  } else {
    u[0] = ctrl_1 * K_d2V; //feedback form tank 1 (left) to left pump
  }

//  Serial.print(ctrl_1);
//  Serial.print("\t");
//  Serial.print(ctrl_2);
//  Serial.print("\t");

  //The values written to u will be aplied to the pumps
}
