#include <Arduino.h>
//#include "include.h"

// FILL IN PART //
// *****************************************//

// Fill in with the calculated PI parameters
//Left pump controller
const double K1   = 0;
const double tau1 = 0;

//Right pump controller
const double K2   = 0;
const double tau2 = 0;

//Use this section for tuning only
const double K_p1 = 1 * K1;
const double K_p2 = 1 * K2;
const double tau_1 = 1 * tau1;
const double tau_2 = 1 * tau2;
// *****************************************//


void pi_controller(double y[4], unsigned int u[2]) {

  error1 = h1_ss - (y[0] - h1_offset);
  sumError1 += error1 * TIMESTEP * 0.001; //integral of the error
  ctrl_1 = K_p1 * error1 + K_p1 / tau_1 * sumError1; 
  
  error2 = h2_ss - (y[1] - h2_offset);
  sumError2 += error2 * TIMESTEP * 0.001; //integral of the error
  ctrl_2 = K_p2 * error2 + K_p2 / tau_2 * sumError2;

  // to avoid negative int conversion to large unsigned int
  if (ctrl_2 < 0) {
    u[1] = 0;
  } else {
    u[1] = ctrl_2 * K_d2V; //feedback from tank 2 (right) to right pump
  }
  if (ctrl_1 < 0) {
    u[0] = 0;
  } else {
    u[0] = ctrl_1 * K_d2V; //feedback form tank 1 (left) to left pump
  }

//  Serial.print(sumError1);
//  Serial.print("\t");
//  Serial.print(sumError2);
//  Serial.print("\t");

  //The values written to u will be aplied to the pumps
}
