#include <Arduino.h>
//#include "include.h"


// FILL IN PART //
// *****************************************//
//decoupling
const double alpha1 = 0;
const double beta1  = 0;
const double alpha2 = 0;
const double beta2  = 0;
// *****************************************//


//int error1 = 0;
//double sumError1 = 0.0;
//int error2 = 0;
//double sumError2 = 0.0;
//const int h1_ss_A = h1_ss * 33.42;
//const int h2_ss_A = h2_ss * 33.42;
//int ctrl_1;
//int ctrl_2;


void pi_controller_dec(double y[4], unsigned int u[2]) {

  error1 = h1_ss - (y[0] - h1_offset);
  sumError1 += error1 * TIMESTEP * 0.001; //integral of the error
  ctrl_1 = K_p1 * error1 + K_p1 / tau_1 * sumError1;
  
  error2 = h2_ss - (y[1] - h2_offset);
  sumError2 += error2 * TIMESTEP * 0.001; //integral of the error
  ctrl_2 = K_p2 * error2 + K_p2 / tau_2 * sumError2; 

  //decoupling
  y_z2 = alpha1 * ctrl_2_old - beta1 * y_z2_old; //discrete time tf
  y_z1 = alpha2 * ctrl_1_old - beta2 * y_z1_old; //discrete time tf

  y_z1_old = y_z1;  //values storage for next step
  y_z2_old = y_z2;
  ctrl_1_old = ctrl_1;
  ctrl_2_old = ctrl_2;

  ctrl_1 = ctrl_1 + y_z2; //decoupled control input
  ctrl_2 = ctrl_2 + y_z1; //decoupled control input

//  Serial.print(y_z1_old);
//  Serial.print("\t");
//  Serial.print(y_z2_old);
//  Serial.print("\t");
  
  // to avoid negative int conversion to large unsigned int
  if (ctrl_2 < 0) {
    u[1] = 0;
  } else {
    u[1] = ctrl_2 * K_d2V; //tank 1 controlled by right pump
  }
  if (ctrl_1 < 0) {
    u[0] = 0;
  } else {
    u[0] = ctrl_1 * K_d2V; //tank 2 controlled by left pump
  }

  //The values written to u will be aplied to the pumps
}
