%% You as a controller ! 
% In order to get the right flow ratio, which is gamma = .7 ... .8  etc
% etc,

clc
  
meas_time = 120; %[s]
port = 'COM5';
baud = 115200;


delete(instrfindall);   %pre-emptively close all ports
s1 = serial(port);    %define serial port to read the Arduino
s1.BaudRate=baud;     %define baud rate
fopen(s1);

%% Tanks 1 and 4

disp("Get ready to set up the throttles for the outlets of tanks 1 and 4 on the left side of the tanks")
disp("After you press any key the water will slowly be pumped in to the tanks 1 and 4");
pause;

fclose(s1);
fopen(s1);
pause(5);

flushinput(s1)
fprintf(s1,'%s\r\n','b'); %turn on left pump to low power

while(s1.BytesAvailable <= 0)  %wait until Arduino outputs data
    %
end
gamma_shouldbe = 0.7;
Timecounter = 0;
realGamma = [];
mData = [];
count = 0;
time = 0;
close all
hold on
plotGraph1 = plot(time,0,'-r');
plotGraph2 = plot(time,0,'-g');
plotGraph3 = plot(time,0,'-b');
plotGraph4 = plot(time,0,'-y');
ylabel('[cm]')
xlabel('time')
legend('tank 1','tank 2','tank 3','tank 4','location','nw')
i = 0;
for j=1:25
    fscanf(s1);
end
tic
while time(end) < meas_time
    i = i+1;
    
    while(s1.BytesAvailable <= 0)  %wait until Arduino outputs data
    %
    end
    
    fscanf(s1);
    sSerialData = fscanf(s1); %read sensor
    flushinput(s1);
    
    %sSerialData = fscanf(s1); %read sensor
    %flushinput(s1);
    t = strsplit(sSerialData,'\t'); % same character as the Arduino code
    
    %reading is correct
    if size(t,2) == 11
        mData(i,11) = str2double(t(1));
        mData(i,1) = str2double(t(2));
        mData(i,2) = str2double(t(3)); %Tank1 KF vals
        mData(i,3) = str2double(t(4));
        mData(i,4) = str2double(t(5)); %Tank2 KF vals
        mData(i,5) = str2double(t(6));
        mData(i,6) = str2double(t(7)); %Tank3 KF vals
        mData(i,7) = str2double(t(8));
        mData(i,8) = str2double(t(9)); %Tank4 KF vals
        
        if (sqrt(mData(i, 8) / mData(i, 2)) > gamma_shouldbe) && (sqrt(mData(i, 8) / mData(i, 2)) < (gamma_shouldbe + .1))
            Timecounter = Timecounter + 1
            fprintf("This is the resulting gamma at the moment: %f", sqrt(mData(i, 8) / mData(i, 2)))
            fprintf("\n")
            fprintf("Seems OK, if the counter hits 10 Left pump is set up.  COUNTER: %d", Timecounter)
            fprintf("\n")
            realgamma(i, 1) = sqrt(mData(i, 8) / mData(i, 2));
        else
            fprintf("\n")
            fprintf("This is the resulting gamma at the moment: %f", sqrt(mData(i, 8) / mData(i, 2)))
            fprintf("\n")
            fprintf("open the throttle of 4 a tiny bit or close down the throttle for 1 finely")
            Timecounter = 0;
        end
        
        
    else
        realgamma(i, 1) = NaN;
        mData(i,5) = NaN;
        mData(i,1) = NaN;
        mData(i,2) = NaN;
        mData(i,3) = NaN;
        mData(i,4) = NaN;
        mData(i,5) = NaN;
        mData(i,6) = NaN;
        mData(i,7) = NaN;
        mData(i,8) = NaN;
    end
       
    hold on
    count = count+1;
    time(count) = toc;
    

    set(plotGraph1,'XData',time,'YData',mData(:,2)); %Tank1 KF vals
    set(plotGraph2,'XData',time,'YData',mData(:,4)); %Tank2 KF vals
    %set(plotGraph3,'XData',time,'YData',mData(:,6)); %Tank3 KF vals
    %set(plotGraph4,'XData',time,'YData',mData(:,8)); %Tank4 KF vals
    
    %update plots every 20 steps (400ms) to avoid memory overflows
    if mod(i,1) == 0
        pause(0.001);
    end
end

flushinput(s1)
fprintf(s1,'%s\r\n','s'); %turn off pumps

fprintf("\nYou can let the water out.\n");
disp("Press any key to continue");
pause;

if any(isnan(mData(:)))
    fprintf("\nThe measurements were not read properly, please launch the code again.\n");
else
    %offset values
    fprintf("\nThe measurements were read properly\n")
    
    
    %calculate gamma1
    gamma1 = mean(realGamma)
end

% %% Tanks 2 and 3
% 
% fprintf("\nMake sure all tanks are empty.");
% fprintf("\nNow get ready to shut the outlets of tanks 2 and 3.");
% disp("After you press any key, you will have 5 seconds to do so.");
% pause;
% 
% fclose(s1);
% fopen(s1);
% pause(5);
% 
% flushinput(s1)
% fprintf(s1,'%s\r\n','n'); %turn on right pump to max power
% 
% while(s1.BytesAvailable <= 0)  %wait until Arduino outputs data
%     %
% end
% mData = [];
% count = 0;
% time = 0;
% close all
% hold on
% plotGraph1 = plot(time,0,'-r');
% plotGraph2 = plot(time,0,'-g');
% plotGraph3 = plot(time,0,'-b');
% plotGraph4 = plot(time,0,'-y');
% ylabel('[cm]')
% xlabel('time')
% legend('tank 1','tank 2','tank 3','tank 4','location','nw')
% i = 0;
% for j=1:25
%     fscanf(s1);
% end
% tic
% while time(end) < meas_time
%     i = i+1;
%     sSerialData = fscanf(s1); %read sensor
%     %flushinput(s1);
%     t = strsplit(sSerialData,'\t'); % same character as the Arduino code
%     if size(t,2) == 7
%         mData(i,5) = str2double(t(1));
%         mData(i,1) = str2double(t(2));
%         mData(i,2) = str2double(t(3));
%         mData(i,3) = str2double(t(4));
%         mData(i,4) = str2double(t(5));
%     else
%         mData(i,5) = NaN;
%         mData(i,1) = NaN;
%         mData(i,2) = NaN;
%         mData(i,3) = NaN;
%         mData(i,4) = NaN;
%     end
%     
%     hold on
%     count = count+1;
%     time(count) = toc;
%     set(plotGraph1,'XData',time,'YData',mData(:,1));
%     set(plotGraph2,'XData',time,'YData',mData(:,2));
%     set(plotGraph3,'XData',time,'YData',mData(:,3));
%     set(plotGraph4,'XData',time,'YData',mData(:,4));
%     
%     if mod(i,1) == 0
%         pause(0.001);
%     end
% end
% 
% flushinput(s1)
% fprintf(s1,'%s\r\n','s'); %turn off pumps
% delete(instrfindall); %disconect targets
% 
% fprintf("\nYou can let the water out.\n");
% disp("Press any key to continue");
% pause;
% 
% if any(isnan(mData(:)))
%     fprintf("\nThe measurements were not read properly, please launch the code again.\n");
% else
%     %offset values
%     fprintf("\nThe measurements were read properly\n")
%     
%     n_meas = size(mData,1);
%     samp2 = floor(n_meas*0.95);
%     samp1 = floor(n_meas*0.3);
%     %slope of tank 2
%     h2_end = mData(samp2,2);
%     h2_mid = mData(samp1,2);
%     delta_h2=h2_end-h2_mid;
%     %slope of tank 3
%     h3_end = mData(samp2,3);
%     h3_mid = mData(samp1,3);
%     delta_h3=h3_end-h3_mid;
%     
%     %calculate gamma2
%     gamma2=delta_h2/(delta_h2+delta_h3)
% end

%%

%compute the flow ratios for two persons

% %pump voltages
% v1=10;
% v2=10;
%
% %T_flowratios: time till pumps stop
% T_flowratios=10;
%
% %load the init_flow_ratios model
% TargetBuild('flowratios_model')
%
% %flow_ratios
%
% %press a key to start the measurement
% disp([' ']);
% disp(['close the outlet-holes of the 4 tanks your fingers']);
% disp([' ']);
% disp(['press key to start the measurement']);pause;
%
% %pause to get ready
% pause(5);
%
% %start measurement
% TargetRun(T_flowratios);
%
% %wait till measurement is finished
% pause(T_flowratios);
% TargetStop
%
% %read out the measured values
% Y = tg.getlog('outputlog');
% [lines columns] = size (Y);
%
% %slopw of tank 1
% h1_end = Y(lines,1);
% h1_mid = Y(lines-3000,1);
% delta_h1=h1_end-h1_mid;
% %slope of tank 2
% h2_end = Y(lines,2);
% h2_mid = Y(lines-3000,2);
% delta_h2=h2_end-h2_mid;
% %slope of tank 3
% h3_end = Y(lines,3);
% h3_mid = Y(lines-3000,3);
% delta_h3=h3_end-h3_mid;
% %slope of tank 4
% h4_end = Y(lines,4);
% h4_mid = Y(lines-3000,4);
% delta_h4=h4_end-h4_mid;
% 
% %calculate gamma1
% gamma1=delta_h1/(delta_h1+delta_h4)
% 
% %calculate gamma2
% gamma2=delta_h2/(delta_h2+delta_h3)


