%%% KALMANFILTER CHECK %%%

clc
  
meas_time = 15; %[s]
port = 'COM5';
baud = 115200;

h1_ss = 15;
h2_ss = h1_ss;

delete(instrfindall);   %pre-emptively close all ports
s1 = serial(port);    %define serial port to read the Arduino
s1.BaudRate=baud;     %define baud rate
fopen(s1);


while(s1.BytesAvailable <= 0)  %wait until Arduino outputs data
    %
end
flushinput(s1);
fprintf(s1,'%s\r\n','m');

mData = [];
count = 0;
time = 0;

close all
hold on

subplot(2,2,3)
plotGraph1 = plot(time,0,'-r');
hold on
plotGraph2 = plot(time,0,'-b');
hline(h1_ss,'k')
ylabel('level [cm]')
xlabel('time [s]')
legend('KF -- OFF', 'KF -- ON')
title('Tank 1')

subplot(2,2,4)
plotGraph3 = plot(time,0,'-r');
hold on
plotGraph4 = plot(time,0,'-g');
hline(h2_ss,'k')
ylabel('level [cm]')
xlabel('time [s]')
legend('KF -- OFF', 'KF -- ON')
title('Tank 2')


subplot(2,2,1)
plotGraph5 = plot(time,0,'-r');
hold on
plotGraph6 = plot(time,0,'-k');
ylabel('level [cm]')
xlabel('time [s]')
legend('KF -- OFF', 'KF -- ON')
title('Tank 3')

subplot(2,2,2)
plotGraph7 = plot(time,0,'-r');
hold on
plotGraph8 = plot(time,0,'-k');
ylabel('level [cm]')
xlabel('time [s]')
legend('KF -- OFF', 'KF -- ON')
title('Tank 4')

i = 0;

for j=1:25
    fscanf(s1);
end
tic
while time(end) < meas_time
    i = i+1;
    
    while(s1.BytesAvailable <= 0)  %wait until Arduino outputs data
    %
    end
    
    fscanf(s1);
    sSerialData = fscanf(s1); %read sensor
    flushinput(s1);
    
    %sSerialData = fscanf(s1); %read sensor
    %flushinput(s1);
    t = strsplit(sSerialData,'\t'); % same character as the Arduino code

    %reading is correct
    if size(t,2) == 11
        mData(i,11) = str2double(t(1));
        mData(i,1) = str2double(t(2));%/K_L;
        mData(i,2) = str2double(t(3));%/K_L;
        mData(i,3) = str2double(t(4));%/K_L;
        mData(i,4) = str2double(t(5));%/K_L;
        mData(i,5) = str2double(t(6));%/K_L;
        mData(i,6) = str2double(t(7));%/K_L;
        mData(i,7) = str2double(t(8));%/K_L;
        mData(i,8) = str2double(t(9));%/K_L;
    else
        mData(i,5) = NaN;
        mData(i,1) = NaN;
        mData(i,2) = NaN;
        mData(i,3) = NaN;
        mData(i,4) = NaN;
        mData(i,5) = NaN;
        mData(i,6) = NaN;
        mData(i,7) = NaN;
        mData(i,8) = NaN;
    end
       
    hold on
    count = count+1;
    time(count) = toc;
    
    set(plotGraph1,'XData',time,'YData',mData(:,1));
    set(plotGraph2,'XData',time,'YData',mData(:,2));
    
    set(plotGraph3,'XData',time,'YData',mData(:,3));
    set(plotGraph4,'XData',time,'YData',mData(:,4));
    
    set(plotGraph5,'XData',time,'YData',mData(:,5));
    set(plotGraph6,'XData',time,'YData',mData(:,6));
    
    set(plotGraph7,'XData',time,'YData',mData(:,7));
    set(plotGraph8,'XData',time,'YData',mData(:,8));
    
    %update plots every 20 steps (400ms) to avoid memory overflows
    if mod(i,1) == 0
        pause(0.001);
    end
end

% stop the pi controller over serial
flushinput(s1);
fprintf(s1,'%s\r\n','s');
delete(instrfindall);    % close the serial port

