%physical_model
run('setup_tank_parameters.m');

gamma1 = .7;
gamma2 = .7;

%test if one gamma value is ok -> 0 or 1 are not allowed values for gamma
if gamma1==0 | gamma1==1 | gamma2==1 | gamma2==0
    'the values 1 and 0 are not allowed for gamma'
end
 
%set steady state level of tank 1 and tank 2
h1_ss =15;
h2_ss = h1_ss;
%calculation of h2_ss, v1_ss, v2_ss
v = sqrt(2*g)/(kp*(gamma1 + gamma2 -1)) * [gamma2 (gamma2 - 1); (gamma1-1) gamma1] * [o_1*sqrt(h1_ss); o_2*sqrt(h2_ss)];
v1_ss=v(1);
v2_ss=v(2);



%calculation of L3ss and L4ss
h3_ss =((1-gamma2)*kp*v2_ss/(o_3*sqrt(2*g)))^2;
h4_ss =((1-gamma1)*kp*v1_ss/(o_4*sqrt(2*g)))^2;


%constants Ti
 T1 = a/o_1*sqrt(2*h1_ss/g);
 T2 = a/o_2*sqrt(2*h2_ss/g);
 T3 = a/o_3*sqrt(2*h3_ss/g);
 T4 = a/o_4*sqrt(2*h4_ss/g);
 
%A-Matrix
A=[-1/T1 0 1/T3 0
    0 -1/T2 0 1/T4
    0 0 -1/T3 0
    0 0 0 -1/T4];

%B-Matrix
 B=[gamma1*kp/a 0;
     0 gamma2*kp/a
     0 (1-gamma2)*kp/a
     (1-gamma1)*kp/a 0];
 
%C-Matrix
C=[1 0 0 0;
   0 1 0 0];

%D_Matrix
D=[0 0
   0 0];

%zeros of the system
s=tf('s');

detG=T1*T2*kp*kp*gamma1*gamma2/(a*a*(1+s*T1)*(1+s*T2)*(1+s*T3)*(1+s*T4))*...
    ((1+s*T3)*(1+s*T4)-(1-gamma1)*(1-gamma2)/(gamma1*gamma2));

z=zero(detG);


%relative Gain Array
m=gamma1*gamma2/(gamma1+gamma2-1);
RGA=[m 1-m;
    1-m m];

%output
disp([' ']);

disp(['steady-state pump voltages: '])
v1_ss
v2_ss

disp(['steady-state tank levels: ']);
h1_ss
h2_ss
%h3_ss
%h4_ss
 
disp(['The relative gain array of the system is ']);

RGA

disp([' ']);

if ((z(1)<0) & (z(2)<0))
    disp([ 'The system is minimum-phase and has the zeros ',num2str(z(1)),' and ',num2str(z(2))]);
else
    disp([ 'The system is nonminimum-phase and has the zeros ',num2str(z(1)),' and ',num2str(z(2))]);
end



