meas_time = 60;
port = 'COM5';
baud = 115200;

%%%%%

delete(instrfindall);   %pre-emptively close all ports
s1 = serial(port);    %define serial port to read the Arduino
s1.BaudRate=baud;     %define baud rate
fopen(s1);

% start the pi controller over serial
while(s1.BytesAvailable <= 0)  %wait until Arduino outputs data
    %
end
flushinput(s1);
fprintf(s1,'%s\r\n','m');
%s1.ReadAsyncMode = 'continuous';
%readasync(s1)

mData15_movingsteadystate_PS_c = [];
count = 0;
time = 0;

close all
hold on

subplot(1,2,1)
plotGraph1 = plot(time,0,'-r');
hold on
plotGraph2 = plot(time,0,'-b');
ylabel('level [cm]')
ylim([0,30]);
xlabel('time [s]')
legend('SMOOTH -- ON', 'SMOOTH -- OFF')
title('Tank 1')

subplot(1,2,2)
plotGraph3 = plot(time,0,'-r');
hold on
plotGraph4 = plot(time,0,'-g');
ylabel('level [cm]')
ylim([0,30]);
xlabel('time [s]')
legend('SMOOTH -- ON', 'SMOOTH -- OFF')
title('Tank 2')


i = 0;

for j=1:25
    fscanf(s1);
end
tic
while time(end) < meas_time
    i = i+1;
    
    while(s1.BytesAvailable <= 0)  %wait until Arduino outputs data
    %
    end
    fscanf(s1);
    sSerialData = fscanf(s1); %read sensor
    flushinput(s1);
    
    %sSerialData = fscanf(s1); %read sensor
    %flushinput(s1);
    t = strsplit(sSerialData,'\t'); % same character as the Arduino code

    %reading is correct
    %reading is correct
    if size(t,2) == 11
        mData15_movingsteadystate_PS_c(i,11) = str2double(t(1));
        mData15_movingsteadystate_PS_c(i,1) = str2double(t(2))*K_L/ADconv-h1_offset;%/K_L;
        mData15_movingsteadystate_PS_c(i,2) = str2double(t(3))*K_L/ADconv-h1_offset;%/K_L;
        mData15_movingsteadystate_PS_c(i,3) = str2double(t(4))*K_L/ADconv-h1_offset;%/K_L;
        mData15_movingsteadystate_PS_c(i,4) = str2double(t(5))*K_L/ADconv-h1_offset;%/K_L;
        mData15_movingsteadystate_PS_c(i,5) = str2double(t(6))*K_L/ADconv-h1_offset;%/K_L;
        mData15_movingsteadystate_PS_c(i,6) = str2double(t(7))*K_L/ADconv-h1_offset;%/K_L;
        mData15_movingsteadystate_PS_c(i,7) = str2double(t(8))*K_L/ADconv-h1_offset;%/K_L;
        mData15_movingsteadystate_PS_c(i,8) = str2double(t(9))*K_L/ADconv-h1_offset;%/K_L;
    else
        mData15_movingsteadystate_PS_c(i,5) = NaN;
        mData15_movingsteadystate_PS_c(i,1) = NaN;
        mData15_movingsteadystate_PS_c(i,2) = NaN;
        mData15_movingsteadystate_PS_c(i,3) = NaN;
        mData15_movingsteadystate_PS_c(i,4) = NaN;
        mData15_movingsteadystate_PS_c(i,5) = NaN;
        mData15_movingsteadystate_PS_c(i,6) = NaN;
        mData15_movingsteadystate_PS_c(i,7) = NaN;
        mData15_movingsteadystate_PS_c(i,8) = NaN;
    end
       
    hold on
    count = count+1;
    time(count) = toc;
    
    subplot(1,2,1)
    hline(h1_ss,'k')
    
    subplot(1,2,2)
    hline(h2_ss,'k')
    
    set(plotGraph1,'XData',time,'YData',mData15_movingsteadystate_PS_c(:,1));
    set(plotGraph2,'XData',time,'YData',mData15_movingsteadystate_PS_c(:,2));
    
    set(plotGraph3,'XData',time,'YData',mData15_movingsteadystate_PS_c(:,3));
    set(plotGraph4,'XData',time,'YData',mData15_movingsteadystate_PS_c(:,4));
    
    
    %update plots every 20 steps (400ms) to avoid memory overflows
    if mod(i,1) == 0
        pause(0.001);
    end
end%This gathers the data.

% stop the pi controller over serial
flushinput(s1);
fprintf(s1,'%s\r\n','s');
delete(instrfindall);    % close the serial port

